public class AsyncSample {
    public AsyncSample() {}
 
    public void foo() {
        Runnable runnable = new Runnable() {
            public void run() {
                try {
                    Thread.sleep(5000L);
                } catch (InterruptedException ex) {}

                synchronized (AsyncSample.this) {
                    AsyncSample.this.notifyAll();
                }
            }
        };
        
        Thread thread = new Thread(runnable);
        thread.start();
  
        synchronized (this) {
            try {
                wait();
            } catch (InterruptedException ex) {}
        }
 
        System.out.println("񓯊I");
    }
 
    public static void main(String[] args) {
        new AsyncSample().foo();
    }
}
